<?php
session_start();

header('Content-Type: text/html; charset=utf-8');

// kontrola, jestli ěnjaký vtipálek nepřeskočil polovinu instalace
if (isset($_SESSION['last_installation_step'])) {

	$last_step = "install_index";
	$current_step = "check_system";

	if ($_SESSION['last_installation_step'] == $last_step) {
		$_SESSION['last_installation_step'] = $current_step;
	}

	if ($_SESSION['last_installation_step'] != $current_step) {
		header("location: ./".$last_step.".php");
		die();
	}
} else {
	header("location: ./install_index.php");
}

// zjistíme si, jestli systém běží pod linuxem, nebo ne
if (PHP_OS == "Linux") {
	$linux = "<span class='ok'>Ano</span>\n";
} else {
	$linux = "<span class='not_recommanded'>Ne</span> Je doporučeno kRS instalovat na server s Linuxem (nicméně takto by měl také fungovat)\n";
}

// zjistíme verzi php
if (!defined("PHP_VERSION_ID")) {
	$version = explode(".", phpversion());

	$phpversion = $version['0']*10000+$version['1']*100+$version['2'];
} else {
	$phpversion = PHP_VERSION_ID;
}
if ($phpversion < 50200) {
	$php_version = "<span class='error'>".phpversion()."</span> Pro správný běh kRS je vyžadováno PHP verze alespoň 5.2.0\n";
	$cannot_install = true;
} else {
	$php_version = "<span class='ok'>".phpversion()."</span>\n";
}

// kontrola, jestli je dostupná mysql
if (extension_loaded("mysql") && function_exists("mysql_query")) {
	$mysql = "<span class='ok'>Ano</span>\n";
} else {
	$mysql = "<span class='error'>Ne</span> Bez MySQL nelze systém nainstalovat!\n";
	$cannot_install = true;
}

// kontrola, jestli existuje GD
if (extension_loaded("gd") && function_exists("gd_info")) {
	$is_gd_available = "<span class='ok'>Ano</span>\n";
} else {
	$is_gd_available = "<span class='not_recommanded'>Ne</span> Nebudou dostupné funkce pro práci s obrázky (zmenšování)\n";
}

// kontrola allow_url_fopen
if (ini_get("allow_url_fopen") == 1) {
	$allow_url_fopen = "<span class='ok'>Ano</span>\n";
} else {
	$allow_url_fopen = "<span class='error'>Ne</span> Nebude možné stáhnout systém, aktualizace ani nic jiného\n";
	$cannot_install = true;
}

// kontrola mod_rewrite
if(!function_exists('apache_get_modules')) {
	$mod_rewrite = "<span class='not_recommanded'>Nepodařilo se získat data.</span>\n";
} else {
	$mod_rewrite = "<span class='error'>Ne</span> Nelze přistupovat k ostatním stránkám\n";
	if (in_array('mod_rewrite',apache_get_modules())) {
		$mod_rewrite = "<span class='ok'>Ano</span>\n";
	}
}


// kontrola, jestli existuje tidy
if (extension_loaded("tidy")) {
	$tidy = "<span class='ok'>Ano</span>\n";
} else {
	$tidy = "<span class='not_recommanded'>Ne</span> Nebude dostupné \"uklízení\" kódu\n";
}

// kontrola, jeslti existuje ZipArchive
if (class_exists("ZipArchive")) {
	$zip_archive = "<span class='ok'>Ano</span>\n";
} else {
	$zip_archive = "<span class='error'>Ne</span> Nelze rozbalovat zip archivy\n";
	$cannot_install = true;
}

// kontrola, jestli můžu zapisovat do aktuálního adresáře
$path_name = dirname(__FILE__);
if (is_writable($path_name)) {
	$is_root_writtable = "<span class='ok'>Ano</span>\n";
} else {
	$is_root_writtable = "<span class='error'>Ne</span> Změň přístupová práva tak, aby PHP mohlo zapisovat do adresáře, kam chceš instalovat systém\n";
	$cannot_install = true;
}

if (!isset($cannot_install)) {
	$continue_link = "Systémové požadavky jsou splněny. Můžeme <a href='download_and_unpack.php'>pokračovat.</a>\n";
} else {
	$continue_link = "<em>Nelze pokračovat do doby, než budou odstraněny chyby označené červeně.</em>\n";
}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Instalace kRS 3.2 - systémové požadavky</title>

<meta name='author' content='Michal Kváček' />
<meta name='description' content='' />
<meta name='keywords' content='' />
<meta name='robots' content='noindex, nofollow' />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />

<style type='text/css'>
html {
	background: #CACACA;
	padding-top: 5em;
}

a {
	color: #353535;
	font-weight: bold;
}

table {
	border-collapse: collapse;
	width: 75%;
	margin: 10px auto;
	background: #E3E3E3;
}

td {
	border: solid 1px #9C9C9C;
	padding: 5px;
	font-size: 22px;
	line-height: 35px;
}

#container, #logo, #installation_progress {
	width: 80%;
	border: solid 1px #C6C6C6;
	background: #DADADA;
	color: #424242;
	margin: 10px auto;
	padding: 10px;
}

#footer {
	width: 80%;
	margin: 10px auto;
	text-align: center;
	font-size: small;
}

.ok, .error, .not_recommanded {
	font-weight: bold;
	font-size: big;
}

.ok {
	color: #008A00;
}

.error {
	color: #810000;
}

.not_recommanded {
	color: #BD7D00;
}

</style>

</head>
<body>

	<div id='logo'>
		<h1>Instalace kRS 3.2</h1>
	</div>

	<div id='installation_progress'><strong style='color: green'>Zahájení instalace</strong> » <em>Kontrola požadavků</em> » Stažení a rozbalení systému » Přihlášení do databáze » Vytvoření uživatele » Dokončení instalace</div>

	<div id='container'>

		<p>
			<h3>Kontrola PHP komponent nezbytných pro správný chod systému</h3>
		</p>

		<p>
			<table>
				<tr>
					<td>Server běžící na Linuxu: </td>
					<td><?php echo $linux; ?></td>
				</tr>
				<tr>
					<td>Verze PHP: </td>
					<td><?php echo $php_version; ?></td>
				</tr>
				<tr>
					<td>MySQL: </td>
					<td><?php echo $mysql; ?></td>
				</tr>
				<tr>
					<td>GD knihovna: </td>
					<td><?php echo $is_gd_available; ?></td>
				</tr>
				<tr>
					<td>Povolené allow_url_fopen: </td>
					<td><?php echo $allow_url_fopen; ?></td>
				</tr>
				<tr>
					<td>Povolený mod_rewrite:</td>
					<td><?php echo $mod_rewrite; ?></td>
				</tr>
				<tr>
					<td>Existující třída ZipArchive: </td>
					<td><?php echo $zip_archive; ?></td>
				</tr>
				<tr>
					<td>Možnost zapisovat do aktuálního adresáře: </td>
					<td><?php echo $is_root_writtable; ?></td>
				</tr>
				<tr>
					<td><span title='Na funkčnosti to nic nemění - pouze odsadí html kód tak, jak má být'>Tidy</span>: </td>
					<td><?php echo $tidy; ?></td>
				</tr>

			</table>

			<?php echo $continue_link; ?>

		</p>

	</div>

	<div id='footer'>
		&copy; Michal Kváček 2012
	</div>

</body>
</html>
